# $Id: access.py 4070 2010-11-26 15:56:03Z wsl $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.5.0/src/access.py $

from meresco.core import Observable
import re

class AccessException(Exception):
	pass

class RecordAccess(Observable):
	def __init__(self, infra):
		pat = infra.configRoot.get('TrustedIPs', section = 'authentication')
		self.trusted_re = re.compile(pat)
		pat = infra.configRoot.get('RestrictedRecords', section = 'authorization')
		self.restricted_re = re.compile(pat)
		Observable.__init__(self)

	def checkRecordAccess(self, recordId, req):
		uid = req.get('uid')
		if uid is not None:
			return None
		ip = req.get('Headers', {}).get('X-Forwarded-For')
		if self.trusted_re.match(ip):
			return None
		if self.restricted_re.match(recordId):
			raise AccessException(recordId)
		return None
